//#define _CRTDBG_MAP_ALLOC
//#include <stdlib.h>
//#include <crtdbg.h>
//
//#ifdef _DEBUG
//#define DEBUG_NEW new(_NORMAL_BLOCK, __FILE__, __LINE__)
//#define new DEBUG_NEW
//#endif

#include "stdafx.h"
#include <map>
#include <ctime>
#include <math.h> 
#include "Winuser.h"
//#include <vld.h> 

#include "EventClock.h"
#include "GVector.h"
#include "VBASim.h"
#include "RNG.h"
#include <fstream>
#include <sstream>
#include <iomanip>

std::vector<CTStat *> TheCTStats;
std::vector<DTStat *> TheDTStats;
std::vector<PriorityQueue *> TheQueues;
std::vector<Resource1 *> TheResources;

EventCalendar *Calendar;

using namespace std;

//_CrtMemState s1;
//_CrtMemState s2;
//_CrtMemState s3;

/////////////////////////////////////////////////////////////////////////

int  
	NumOfType1,            //Number of Type 1 Customers In System
	NumOfType2,            //Number of Type 2 Customers In System
	NumOfType3,            //Number of Type 3 Customers In System
	cap1 = 120,			   //Capacity of queue1
	cap2 = 120,			   //Capacity of queue2
	cap3 = 120,			   //Capacity of queue3
	counter,
	NumOfArrival1,
	NumOfArrival2,
	NumOfArrival3,
	NumOfServers,
	CustomerType1InService,
	CustomerType2InService,
	CustomerType3InService;

double reparray[10][2] = {{0}};
double inputarray[81][18] = {{0}};
//double outputarray[135][1] = {{0}};

double
	lam1,	//arrival rate of customers type 1
	lam2,	//arrival rate of customers type 2
	lam3,	//arrival rate of customers type 3
	mu1,	//service rate of customer type 1
	mu2,	//service rate of customer type 2
	mu3,	//service rate of customer type 3
	alpha1, alpha2, alpha3, beta1, beta2, beta3,//for service time
	alpha1A, alpha2A, alpha3A, beta1A, beta2A, beta3A,//for patience time
	theta1,	//abandonment rate rate of customer type 1
	theta2,	//abandonment rate of customer type 2
	theta3,	//abandonment rate of customer type 3
	b1,		//cost per unit time of customer type 1 abandonment
	b2,		//cost per unit time of customer type 2 abandonment
	b3,		//cost per unit time of customer type 3 abandonment
	RunLength,
	avgcost,//average over replications
	WarmUp;

enum string_code 
{
	ArrivalOne,
	ArrivalTwo,
	ArrivalThree,
	AbandonOne,
	AbandonTwo,
	AbandonThree,
	EndOfServicee,
	ClearIt,
	EndSimulation
};
string_code hashit (std::string const& inString) 
{
	if (inString == "ArrivalOne") return ArrivalOne;
	if (inString == "ArrivalTwo") return ArrivalTwo;
	if (inString == "ArrivalThree") return ArrivalThree;
	if (inString == "AbandonOne") return AbandonOne;
	if (inString == "AbandonTwo") return AbandonTwo;
	if (inString == "AbandonThree") return AbandonThree;
	if (inString == "EndOfServicee") return EndOfServicee;
    if (inString == "ClearIt") return ClearIt;
	if (inString == "EndSimulation") return EndSimulation;
}

ifstream indata;
ofstream outdata;

////////////////////////////////////////////////////////////////////////////
// Prototype of the System Function

PriorityQueue *Queue;
Resource1 *Server;
DTStat *Sojourn1;
DTStat *Sojourn2;
DTStat *Sojourn3;
DTStat *Wait1;
DTStat *Wait2;
DTStat *Wait3;
DTStat *Abandonment1;
DTStat *Abandonment2;
DTStat *Abandonment3;

void initialize(EventClock *Clock, Resource1 *Server, double myarray[81][18], int row);
void Arrival1(EventClock *Clock, Resource1 *Server);
void Arrival2(EventClock *Clock, Resource1 *Server);
void Arrival3(EventClock *Clock, Resource1 *Server);
void Abandon1(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server);
void Abandon2(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server);
void Abandon3(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server);
void EndOfService(Entity *DepartingCustomer,EventClock *Clock, Resource1 *Server);
void writeToExcel(double outputdata, string filename);
void readFromExcel (string filename);

////////////////////////////////////////////////////////////////////////////////////
//Main Function

int main() 
{
	std::remove ("output.csv");
	std::remove("outputRho.csv");
	EventNotice *NextEvent;
	GVector<CTStat *> TheCTStats;
	int start_s = clock();
	EventClock Clock;
	Server = new Resource1(&TheCTStats, &Clock);
	Queue = new PriorityQueue(&TheCTStats, &Clock);

// Intialization of the System
	//Server = new Resource1(&TheCTStats, &Clock);
	//Queue = new PriorityQueue(&TheCTStats, &Clock);
	std::string dummy;

	readFromExcel ("Input.csv");

	for (int cas = 0; cas < 81; cas++){

	initialize(&Clock, Server, inputarray, cas);

	cout << "* Server scheduling in a multi-server queue with abandonment (Priority)*" << endl;
	cout << "_________________________________________________" << endl << endl;
	cout << "Number of servers: " << NumOfServers << endl;
	cout << "Type 1 arrival rate: " << lam1 << endl;
	cout << "Type 2 arrival rate: " << lam2 << endl;
	cout << "Type 3 arrival rate: " << lam3 << endl;
	cout << "Type 1 service rate: " << 1/(alpha1*beta1) << endl;
	cout << "Type 2 service rate: " << 1/(alpha2*beta2) << endl;
	cout << "Type 3 service rate: " << 1/(alpha3*beta3) << endl;
	cout << "Type 1 abandonment rate: " << 1 / (alpha1A*beta1A) << endl;
	cout << "Type 2 abandonment rate: " << 1 / (alpha2A*beta2A) << endl;
	cout << "Type 3 abandonment rate: " << 1 / (alpha3A*beta3A) << endl;
	cout << "Type 1 abandonment cost: " << b1 << endl;
	cout << "Type 2 abandonment cost: " << b2 << endl;
	cout << "Type 3 abandonment cost: " << b3 << endl << endl;


	//_CrtMemCheckpoint( &s1 );
	//_CrtMemDumpStatistics( &s1 );

	for (int Reps = 0; Reps< 10; Reps++) {

		NumOfType1 = 0;
		NumOfType2 = 0;
		NumOfType3 = 0;
		NumOfArrival1 = 0;
		NumOfArrival2 = 0;
		NumOfArrival3 = 0;
		CustomerType1InService = 0;
		CustomerType2InService = 0;
		CustomerType3InService = 0;
		counter = 0;
		//EventClock Clock;
		//counterL = 0;

		VBASimInit(&Clock, Server);

		Schedule("ArrivalOne", expon(1/lam1,1), &Clock);
		Schedule("ArrivalTwo", expon(1/lam2,2), &Clock);
		Schedule("ArrivalThree", expon(1/lam3,3), &Clock);
		Schedule("EndSimulation", RunLength, &Clock);
		Schedule("ClearIt", WarmUp, &Clock);

		//outdata.open("detailAnalysis1.csv", ios::app);

		do {
			//double bbpoint = Clock.getClock();
			NextEvent = Calendar->Remove();
			dummy = NextEvent->EventType;
			Clock.setClock(NextEvent->EventTime);
			switch (hashit(dummy))
			{
			case ArrivalOne:
				Arrival1(&Clock, Server);
				break;
			case ArrivalTwo:
				Arrival2(&Clock, Server);
				break;
			case ArrivalThree:
				Arrival3(&Clock, Server);
				break;
			case AbandonOne:
				Abandon1(NextEvent->WhichObject, &Clock, Server);
				break;
			case AbandonTwo:
				Abandon2(NextEvent->WhichObject, &Clock, Server);
				break;
			case AbandonThree:
				Abandon3(NextEvent->WhichObject, &Clock, Server);
				break;
			case EndOfServicee:
				EndOfService(NextEvent->WhichObject, &Clock, Server);
				break;
			case ClearIt:
				ClearStats();
				break;
			default:
				break;
			}
			//cout << "\n Clock: " << bbpoint;
			delete NextEvent;
		} while (hashit(dummy)!= EndSimulation);
		// Write output report for each replication

		//cout << "\n Average wait type 1: " << Wait1->Mean();
		//cout << "\n Average wait type 2: " << Wait2->Mean();
		//cout << "\n Average wait type 3: " << Wait3->Mean();
		//cout << "\n Average # in Queue: " << Queue->Mean();
		//cout << "\n Server Utilization: " << Server->Mean();
		//cout << "\n # of type 1 reneged: " << Abandonment1->N();
		//cout << "\n # of type 2 reneged: " << Abandonment2->N();
		//cout << "\n # of type 3 reneged: " << Abandonment3->N();
		//cout << "\n Average Abandonment Cost: " << (b1*Abandonment1->N() + b2*Abandonment2->N() + b3*Abandonment3->N()) / (RunLength - WarmUp);
		//cout << "\n Number of Arrival 1: " << NumOfArrival1;
		//cout << "\n Number of Arrival 2: " << NumOfArrival2;
		//cout << "\n Number of Arrival 3: " << NumOfArrival3 << endl << endl << endl;

		reparray[Reps][0] = (b1*Abandonment1->N() + b2*Abandonment2->N() + b3*Abandonment3->N()) / (RunLength - WarmUp);
		reparray[Reps][1] = Server->Mean();
	}

	//Caculate the average cost of abandonment over replications
	double sumreps = 0;
	double sumrho = 0;

	for (int i = 0; i < 10; i++) {
		sumreps = sumreps + reparray[i][0];
		sumrho = sumrho + reparray[i][1];
	}
	writeToExcel(sumreps / 10.0, "output.csv");
	writeToExcel(sumrho / 10.0, "outputRho.csv");

	cout << "\n Case #: " << cas << endl;
	cout << "\n Rho: " << sumrho / 10.0 << endl;
	cout << "\n Avg Cost over Replications: " << sumreps / 10.0 << endl << endl;

	//delete Calendar;
	//delete Wait1;
	//delete Wait2;
	//delete Abandonment1;
	//delete Abandonment2;
	//delete Server;
	//delete Queue;
	}

	//_CrtMemCheckpoint( &s2 );
	//_CrtMemDumpStatistics( &s2 );


	//get the time
	int stop_s=clock();
	cout << "time: " << (stop_s-start_s)/(double(CLOCKS_PER_SEC) * 60) <<" mins" << endl;
	
	MessageBox(NULL,(LPCWSTR)L"Running is complete!", (LPCWSTR)L"Status", MB_OK);

	cin.get();

	return (0);
}

//////////////////////////////////////////////////////////////////////////////
//Intialization Function
void initialize(EventClock *Clock, Resource1 *Server, double myarray[81][18], int row) 
{
	Calendar = new EventCalendar();
	Sojourn1 = new DTStat();
	Sojourn2 = new DTStat();
	Sojourn3 = new DTStat();
	Wait1 = new DTStat();
	Wait2 = new DTStat();
	Wait3 = new DTStat();
	Abandonment1 = new DTStat();
	Abandonment2 = new DTStat();
	Abandonment3 = new DTStat();

	NumOfServers = 10;

	Server->SetUnits (NumOfServers); // set the number of servers to 1
	//lam1 = 0.25;
	//lam2 = 0.25;
	//lam3 = 0;
	//mu1 = 1;
	//mu2 = 1;
	//mu3 = 1;
	//theta1 = 0;
	//theta2 = 0;
	//theta3 = 0;
	//b1 = 1;
	//b2 = 1;
	//b3 = 1;
	lam1 = myarray[row][0];
	lam2 = myarray[row][1];
	lam3 = myarray[row][2];
	//mu1 = myarray[row][2];
	//mu2 = myarray[row][3];
	alpha1 = myarray[row][3];
	beta1 = myarray[row][4];
	alpha2 = myarray[row][5];
	beta2 = myarray[row][6];
	alpha3 = myarray[row][7];
	beta3 = myarray[row][8];
	alpha1A = myarray[row][9];
	beta1A = myarray[row][10];
	alpha2A = myarray[row][11];
	beta2A = myarray[row][12];
	alpha3A = myarray[row][13];
	beta3A = myarray[row][14];
	//theta1 = myarray[row][15];
	//theta2 = myarray[row][16];
	//theta3 = myarray[row][17];
	b1 = myarray[row][15];
	b2 = myarray[row][16];
	b3 = myarray[row][17];
	RunLength = 100000;
	WarmUp = 5000;

	TheDTStats.push_back(Sojourn1);
	TheDTStats.push_back(Sojourn2);
	TheDTStats.push_back(Sojourn3);
	TheDTStats.push_back(Wait1);//wait-times are computed for patients who do not abandon
	TheDTStats.push_back(Wait2);
	TheDTStats.push_back(Wait3);
	TheDTStats.push_back(Abandonment1);
	TheDTStats.push_back(Abandonment2);
	TheDTStats.push_back(Abandonment3);
	TheQueues.push_back(Queue); ///????????????????????????why do we need TheQueues?
	TheResources.push_back(Server);
}

////////////////////////////////////////////////////////////////////////////
// Type 1 Customer Arriving function

void Arrival1(EventClock *Clock, Resource1 *Server) 
{ //Schedule next arrival
	NumOfArrival1 ++;
	Schedule("ArrivalOne", expon(1/lam1,1), Clock);

	Entity *Customer = new Entity(Clock);
	//cout << "\n Address: " << Customer << endl;
	Customer->Type = 1;
	Customer->Priority = 3;
	Customer->ServiceT = gamma(alpha1, beta1, 4); //expon(1/mu1,4);
	Customer->PatienceT = gamma(alpha1A, beta1A, 7); //expon(1/theta1,7);

	// If server is not busy, start service by seizing the server
	if (Server->Busy < NumOfServers) {
			//CustomerTypeInService = Customer->Type;
			Customer->WaitT = Clock->getClock() - Customer->CreateTime;
			Customer->Status = 'S';
			Server->Seize (1, Customer);
			CustomerType1InService++;
			NumOfType1++;
			SchedulePlus("AbandonOne", Customer->PatienceT, Customer, Clock);
			SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//if (Customer->ServiceT < Customer->PatienceT){
		//	SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//} else {
		//	SchedulePlus("AbandonOne", Customer->PatienceT, Customer, Clock);
		//}
	} else {
		if (NumOfType1 - CustomerType1InService < cap1) {
			Customer->Status = 'Q';
			Queue->Add(Customer);
			SchedulePlus("AbandonOne", Customer->PatienceT, Customer, Clock);
			NumOfType1++;
		}
		else {
			delete Customer;
		}
		//if(CustomerTypeInService == 1){
		//	if (NumOfType1 < cap1-1){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonOne", Customer->PatienceT, Customer, Clock);
		//		NumOfType1 = NumOfType1 + 1;
		//	} else {
		//		delete Customer;}
		//} else {
		//	if (NumOfType1 < cap1){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonOne", Customer->PatienceT, Customer, Clock);
		//		NumOfType1 = NumOfType1 + 1;
		//	} else {
		//		delete Customer;}
		//}
	}
}

////////////////////////////////////////////////////////////////////////////
// Type 2 Customer Arriving  function

void Arrival2(EventClock *Clock, Resource1 *Server) 
{
	NumOfArrival2 ++;
	//Schedule next arrival
	Schedule("ArrivalTwo", expon(1/lam2,2), Clock);

	Entity *Customer = new Entity(Clock);
	Customer->Type = 2;
	Customer->Priority = 2;
	Customer->ServiceT = gamma(alpha2, beta2, 5); //expon(1/mu2,5);
	Customer->PatienceT = gamma(alpha2A, beta2A, 8); //expon(1/theta2,8);

	// If server is not busy, start service by seizing the server

	if (Server->Busy < NumOfServers) {
			//CustomerTypeInService = Customer->Type;
			Customer->WaitT = Clock->getClock() - Customer->CreateTime;
			Customer->Status = 'S';
			Server->Seize (1, Customer);
			CustomerType2InService++;
			NumOfType2++;
			SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
			SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//if (Customer->ServiceT < Customer->PatienceT){
		//	SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//} else {
		//	SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
		//}
	} else {
		if (NumOfType2 - CustomerType2InService < cap2) {
			Customer->Status = 'Q';
			Queue->Add(Customer);
			SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
			NumOfType2++;
		}
		else {
			delete Customer;
		}
		//if(CustomerTypeInService == 2){
		//	if (NumOfType2 < cap2-1){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
		//		NumOfType2 ++;
		//	} else {
		//		delete Customer;}
		//} else {
		//	if (NumOfType2 < cap2){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
		//		NumOfType2 ++;
		//	} else {
		//		delete Customer;}
		//}
	}
}

////////////////////////////////////////////////////////////////////////////
// Type 3 Customer Arriving  function

void Arrival3(EventClock *Clock, Resource1 *Server)
{
	NumOfArrival3++;
	//Schedule next arrival
	Schedule("ArrivalThree", expon(1/lam3,3), Clock);

	Entity *Customer = new Entity(Clock);
	Customer->Type = 3;
	Customer->Priority = 1;
	Customer->ServiceT = gamma(alpha3, beta3, 6); ;//expon(1/mu3,6);
	Customer->PatienceT = gamma(alpha3A, beta3A, 9); //expon(1/theta3,9);

	// If server is not busy, start service by seizing the server

	if (Server->Busy < NumOfServers) {
		//CustomerTypeInService = Customer->Type;
		Customer->WaitT = Clock->getClock() - Customer->CreateTime;
		Customer->Status = 'S';
		Server->Seize(1, Customer);
		CustomerType3InService++;
		NumOfType3++;
		SchedulePlus("AbandonThree", Customer->PatienceT, Customer, Clock);
		SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//if (Customer->ServiceT < Customer->PatienceT) {
		//	SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//}
		//else {
		//	SchedulePlus("AbandonThree", Customer->PatienceT, Customer, Clock);
		//}
	}
	else {
		if (NumOfType3 - CustomerType3InService < cap3) {
			Customer->Status = 'Q';
			Queue->Add(Customer);
			SchedulePlus("AbandonThree", Customer->PatienceT, Customer, Clock);
			NumOfType3++;
		}
		else {
			delete Customer;
		}
		//if(CustomerTypeInService == 2){
		//	if (NumOfType2 < cap2-1){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
		//		NumOfType2 ++;
		//	} else {
		//		delete Customer;}
		//} else {
		//	if (NumOfType2 < cap2){
		//		Queue->Add(Customer);
		//		Customer->Status = 'Q';
		//		SchedulePlus("AbandonTwo", Customer->PatienceT, Customer, Clock);
		//		NumOfType2 ++;
		//	} else {
		//		delete Customer;}
		//}
	}
}

////////////////////////////////////////////////////////////////////////////
// Type 1 Customer Abandonment function

void Abandon1(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server)
{
	//Check whether the customer is still in the queue
	if (DepartingCustomer->Status == 'Q') {//& DepartingCustomer->WaitT > DepartingCustomer->PatienceT
		//if (DepartingCustomer->CreateTime + DepartingCustomer->PatienceT == Clock->getClock()) {

		//update stats
		Sojourn1->Record(Clock->getClock() - DepartingCustomer->CreateTime); //update the sojourn time
		Abandonment1->Record(Clock->getClock() - DepartingCustomer->CreateTime);//update the number of abandonments
		NumOfType1--;

		//Update queue
		DepartingCustomer->Status = 'A'; 				//Specify that the customer is abandoned, to avoid trigger an EndOfService event
		Queue->Renege(Queue->Position(DepartingCustomer));//remove departing customer from queue
		delete DepartingCustomer;
	}
	else if (DepartingCustomer->Status == 'S') { 
		DepartingCustomer->Status = 'B'; 
	}
	else { delete DepartingCustomer;
	}
	//else if (DepartingCustomer->Status == 'S') {
	//			CustomerType1InService--;
	//			if (NumOfType1 + NumOfType2 + NumOfType3 < NumOfServers) {
	//				Server->Free(1);
	//				DepartingCustomer-> Status = 'A';
	//				delete DepartingCustomer;
	//			} else {
	//				//cout << "input " << input[NumOfType1][NumOfType2];
	//				Server->Free(1);
	//				DepartingCustomer-> Status = 'A';
	//				Entity *Customer = new Entity(Clock);
	//				Customer = Queue->Remove();
	//				Customer->WaitT = Clock->getClock() - Customer->CreateTime;
	//				Customer->Status = 'S';
	//				Server->Seize(1,Customer);
	//				if (Customer->Type == 1) {
	//					CustomerType1InService++;
	//				}
	//				else if (Customer->Type == 2) {
	//					CustomerType2InService++;
	//				}
	//				else {
	//					CustomerType3InService++;
	//				}
	//				SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);	
	//			}
	//		}	
}

////////////////////////////////////////////////////////////////////////////
// Type 2 Customer Abandonment function

void Abandon2(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server)
{
	//Check whether the customer is still in the queue
	if (DepartingCustomer->Status == 'Q') {
		//if (DepartingCustomer->CreateTime + DepartingCustomer->PatienceT == Clock->getClock()) {

		//update stats
		Sojourn2->Record(Clock->getClock() - DepartingCustomer->CreateTime); //update the sojourn time
		Abandonment2->Record(Clock->getClock() - DepartingCustomer->CreateTime);//update the number of abandonments
		NumOfType2--;

		//Update queue
		DepartingCustomer->Status = 'A'; 				//Specify that the customer is abandoned, to avoid trigger an EndOfService event
		Queue->Renege(Queue->Position(DepartingCustomer));//remove departing customer from queue
		delete DepartingCustomer;
	}
	else if (DepartingCustomer->Status == 'S'){ 
		DepartingCustomer->Status = 'B';
	}
	else { delete DepartingCustomer; }
  //else {
		//		CustomerType2InService = CustomerType2InService - 1;
		//		if (NumOfType1 + NumOfType2 + NumOfType3 < NumOfServers) {
		//			Server->Free(1);
		//			DepartingCustomer-> Status = 'A';
		//			delete DepartingCustomer;
		//		} else {
		//			//cout << "input " << input[NumOfType1][NumOfType2];
		//			Server->Free(1);//delete the entity in server
		//			DepartingCustomer-> Status = 'A';
		//			//delete DepartingCustomer;
		//			Entity *Customer = new Entity(Clock);
		//			Customer = Queue->Remove();
		//			Customer->WaitT = Clock->getClock() - Customer->CreateTime;
		//			Customer->Status = 'S';
		//			Server->Seize(1,Customer);
		//			if (Customer->Type == 1) {
		//				CustomerType1InService++;
		//			}
		//			else if (Customer->Type == 2) {
		//				CustomerType2InService++;
		//			}
		//			else {
		//				CustomerType3InService++;
		//			}
		//			SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
		//		}
		//	}	
}

////////////////////////////////////////////////////////////////////////////
// Type 3 Customer Abandonment function

void Abandon3(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server)
{
	//Check whether the customer is still in the queue
	if (DepartingCustomer->Status == 'Q') {
		//if (DepartingCustomer->CreateTime + DepartingCustomer->PatienceT == Clock->getClock()) {

		//update stats
		Sojourn3->Record(Clock->getClock() - DepartingCustomer->CreateTime); //update the sojourn time
		Abandonment3->Record(Clock->getClock() - DepartingCustomer->CreateTime);//update the number of abandonments
		NumOfType3--;

		//Update queue
		DepartingCustomer->Status = 'A'; 				//Specify that the customer is abandoned, to avoid trigger an EndOfService event
		Queue->Renege(Queue->Position(DepartingCustomer));//remove departing customer from queue
		delete DepartingCustomer;
	}
	else if (DepartingCustomer->Status == 'S') { 
		DepartingCustomer->Status = 'B'; 
	}
	else { delete DepartingCustomer; }
	//else {
	//		//cout << "input " << input[NumOfType1][NumOfType2];
	//		Server->Free(1);//delete the entity in server
	//		DepartingCustomer->Status = 'A';
	//		delete DepartingCustomer;
	//		Entity *Customer = new Entity(Clock);
	//		Customer = Queue->Remove();
	//		Customer->WaitT = Clock->getClock() - Customer->CreateTime;
	//		Customer->Status = 'S';
	//		Server->Seize(1, Customer);
	//		if (Customer->Type == 1) {
	//			CustomerType1InService++;
	//		}
	//		else if (Customer->Type == 2) {
	//			CustomerType2InService++;
	//		}
	//		else {
	//			CustomerType3InService++;
	//		}
	//		SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
	//	}
}

/////////////////////////////////////////////////////////////////////////////
// EndOfService Customer Function

void EndOfService(Entity *DepartingCustomer, EventClock *Clock, Resource1 *Server)
{
	if (DepartingCustomer->Status == 'S' || DepartingCustomer->Status == 'B'){
	//Remove departing customer from queue and record wait time	
		//avoid the customer added back to the system to be served with the intial endofservice
		//if (DepartingCustomer->CreateTime + DepartingCustomer->WaitT + DepartingCustomer->ServiceT == Clock->getClock()){

			if (DepartingCustomer->Type == 1) {
				NumOfType1--;
				CustomerType1InService--;
				Sojourn1->Record(Clock->getClock() - DepartingCustomer->CreateTime);
				Wait1->Record(DepartingCustomer->WaitT);
			}
			else if (DepartingCustomer->Type == 2) {
				NumOfType2--;
				CustomerType2InService--;
				Sojourn2->Record(Clock->getClock() - DepartingCustomer->CreateTime);
				Wait2->Record(DepartingCustomer->WaitT);
			}
			else {
				NumOfType3--;
				CustomerType3InService--;
				Sojourn3->Record(Clock->getClock() - DepartingCustomer->CreateTime);
				Wait3->Record(DepartingCustomer->WaitT);
			}

			Server->Free(1, Server->Position(DepartingCustomer));//delete the entity in server


			if (DepartingCustomer->Status == 'B') {//remove the entity 
				delete DepartingCustomer;
			}
			else {//for entity that did not abandon
				DepartingCustomer->Status = 'L';
			}

			//Check to see if there is another customer; if yes start service otherwise free the server
			if (NumOfType1 + NumOfType2 + NumOfType3 >= NumOfServers) {
					Entity *Customer = Queue->Remove();
					Customer->WaitT = Clock->getClock() - Customer->CreateTime;
					Customer->Status = 'S';
					Server->Seize(1, Customer);
					if (Customer->Type == 1) {
						CustomerType1InService++;
					}
					else if (Customer->Type == 2) {
						CustomerType2InService++;
					}
					else {
						CustomerType3InService++;
					}
					SchedulePlus("EndOfServicee", Customer->ServiceT, Customer, Clock);
			} 
	}
}


void readFromExcel (string filename)
{
    std::ifstream file(filename);

    for(int row = 0; row < 81; row++)
    {
        std::string line;
        std::getline(file, line);
        if ( !file.good() )
            break;

        std::stringstream iss(line);

        for (int col = 0; col < 18; col++)
        {
            std::string val;
            std::getline(iss, val, ',');
            if ( !iss.good() )
                break;

            std::stringstream convertor(val);
            convertor >> inputarray[row][col];
        }
    }
}

void writeToExcel(double outputdata, string filename)
{
	ofstream outdata;
	outdata.open(filename, ios::app);
    outdata << endl << outputdata;

	/*for (int i = 0; i < 135; i++)
	{
		outdata << endl << dataTable[i][0];
	}*/
}
